package com.sun.java.swing.plaf.windows;

import java.awt.event.ActionEvent;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Arrays;
import sun.awt.shell.ShellFolder;
import java.util.Vector;
import javax.swing.ComboBoxModel;
import javax.swing.AbstractListModel;
import javax.swing.DefaultListCellRenderer;
import javax.swing.plaf.basic.BasicDirectoryModel;
import java.awt.event.MouseListener;
import javax.swing.JList;
import javax.swing.filechooser.FileView;
import javax.swing.event.ListSelectionEvent;
import java.awt.Component;
import javax.swing.DefaultButtonModel;
import javax.swing.Icon;
import javax.swing.Action;
import java.awt.ComponentOrientation;
import javax.swing.filechooser.FileSystemView;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.ActionMapUIResource;
import javax.swing.ActionMap;
import sun.swing.SwingUtilities2;
import java.util.Locale;
import java.awt.Graphics;
import javax.swing.plaf.InsetsUIResource;
import java.awt.event.FocusEvent;
import java.awt.event.FocusAdapter;
import javax.swing.BoxLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyAdapter;
import javax.swing.SwingUtilities;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import javax.swing.ImageIcon;
import java.awt.Color;
import java.awt.image.BufferedImage;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.ButtonGroup;
import javax.swing.UIManager;
import javax.swing.Box;
import javax.swing.JToolBar;
import java.awt.BorderLayout;
import javax.swing.border.EmptyBorder;
import javax.swing.JFileChooser;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import java.awt.Insets;
import java.awt.Dimension;
import javax.swing.filechooser.FileFilter;
import javax.swing.JButton;
import sun.swing.WindowsPlacesBar;
import sun.swing.FilePane;
import javax.swing.JTextField;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.plaf.basic.BasicFileChooserUI;

public class WindowsFileChooserUI extends BasicFileChooserUI
{
    private JPanel centerPanel;
    private JLabel lookInLabel;
    private JComboBox<File> directoryComboBox;
    private WindowsFileChooserUI.DirectoryComboBoxModel directoryComboBoxModel;
    private ActionListener directoryComboBoxAction;
    private WindowsFileChooserUI.FilterComboBoxModel filterComboBoxModel;
    private JTextField filenameTextField;
    private FilePane filePane;
    private WindowsPlacesBar placesBar;
    private JButton approveButton;
    private JButton cancelButton;
    private JPanel buttonPanel;
    private JPanel bottomPanel;
    private JComboBox<FileFilter> filterComboBox;
    private static final Dimension hstrut10;
    private static final Dimension vstrut4;
    private static final Dimension vstrut6;
    private static final Dimension vstrut8;
    private static final Insets shrinkwrap;
    private static int PREF_WIDTH;
    private static int PREF_HEIGHT;
    private static Dimension PREF_SIZE;
    private static int MIN_WIDTH;
    private static int MIN_HEIGHT;
    private static int LIST_PREF_WIDTH;
    private static int LIST_PREF_HEIGHT;
    private static Dimension LIST_PREF_SIZE;
    private int lookInLabelMnemonic;
    private String lookInLabelText;
    private String saveInLabelText;
    private int fileNameLabelMnemonic;
    private String fileNameLabelText;
    private int folderNameLabelMnemonic;
    private String folderNameLabelText;
    private int filesOfTypeLabelMnemonic;
    private String filesOfTypeLabelText;
    private String upFolderToolTipText;
    private String upFolderAccessibleName;
    private String newFolderToolTipText;
    private String newFolderAccessibleName;
    private String viewMenuButtonToolTipText;
    private String viewMenuButtonAccessibleName;
    private BasicFileChooserUI.BasicFileView fileView;
    private JLabel fileNameLabel;
    static final int space = 10;
    
    private void populateFileNameLabel() {
        if (this.getFileChooser().getFileSelectionMode() == 1) {
            this.fileNameLabel.setText(this.folderNameLabelText);
            this.fileNameLabel.setDisplayedMnemonic(this.folderNameLabelMnemonic);
        }
        else {
            this.fileNameLabel.setText(this.fileNameLabelText);
            this.fileNameLabel.setDisplayedMnemonic(this.fileNameLabelMnemonic);
        }
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsFileChooserUI((JFileChooser)component);
    }
    
    public WindowsFileChooserUI(JFileChooser b) {
        super(b);
        this.directoryComboBoxAction = new WindowsFileChooserUI.DirectoryComboBoxAction();
        this.lookInLabelMnemonic = 0;
        this.lookInLabelText = null;
        this.saveInLabelText = null;
        this.fileNameLabelMnemonic = 0;
        this.fileNameLabelText = null;
        this.folderNameLabelMnemonic = 0;
        this.folderNameLabelText = null;
        this.filesOfTypeLabelMnemonic = 0;
        this.filesOfTypeLabelText = null;
        this.upFolderToolTipText = null;
        this.upFolderAccessibleName = null;
        this.newFolderToolTipText = null;
        this.newFolderAccessibleName = null;
        this.viewMenuButtonToolTipText = null;
        this.viewMenuButtonAccessibleName = null;
        this.fileView = new WindowsFileChooserUI.WindowsFileView();
    }
    
    @Override
    public void installUI(JComponent c) {
        super.installUI(c);
    }
    
    @Override
    public void uninstallComponents(JFileChooser fileChooser) {
        fileChooser.removeAll();
    }
    
    @Override
    public void installComponents(JFileChooser fc) {
        fc.addPropertyChangeListener(this.filePane = new FilePane(new WindowsFileChooserUI.WindowsFileChooserUIAccessor()));
        fc.getFileSystemView();
        fc.setBorder(new EmptyBorder(4, 10, 10, 10));
        fc.setLayout(new BorderLayout(8, 8));
        this.updateUseShellFolder();
        JToolBar comp = new JToolBar();
        comp.setFloatable(false);
        comp.putClientProperty("JToolBar.isRollover", Boolean.TRUE);
        fc.add(comp, "North");
        (this.lookInLabel = new JLabel(this.lookInLabelText, 11) {
            @Override
            public Dimension getPreferredSize() {
                return this.getMinimumSize();
            }
            
            @Override
            public Dimension getMinimumSize() {
                Dimension preferredSize = super.getPreferredSize();
                if (WindowsFileChooserUI.this.placesBar != null) {
                    preferredSize.width = Math.max(preferredSize.width, WindowsFileChooserUI.this.placesBar.getWidth());
                    return preferredSize;
                }
                return preferredSize;
            }
        }).setDisplayedMnemonic(this.lookInLabelMnemonic);
        this.lookInLabel.setAlignmentX(0.0f);
        this.lookInLabel.setAlignmentY(0.5f);
        comp.add(this.lookInLabel);
        comp.add(Box.createRigidArea(new Dimension(8, 0)));
        (this.directoryComboBox = new JComboBox<File>() {
            @Override
            public Dimension getMinimumSize() {
                Dimension minimumSize = super.getMinimumSize();
                minimumSize.width = 60;
                return minimumSize;
            }
            
            @Override
            public Dimension getPreferredSize() {
                Dimension preferredSize = super.getPreferredSize();
                preferredSize.width = 150;
                return preferredSize;
            }
        }).putClientProperty("JComboBox.lightweightKeyboardNavigation", "Lightweight");
        this.lookInLabel.setLabelFor(this.directoryComboBox);
        this.directoryComboBoxModel = this.createDirectoryComboBoxModel(fc);
        this.directoryComboBox.setModel(this.directoryComboBoxModel);
        this.directoryComboBox.addActionListener(this.directoryComboBoxAction);
        this.directoryComboBox.setRenderer(this.createDirectoryComboBoxRenderer(fc));
        this.directoryComboBox.setAlignmentX(0.0f);
        this.directoryComboBox.setAlignmentY(0.5f);
        this.directoryComboBox.setMaximumRowCount(8);
        comp.add(this.directoryComboBox);
        comp.add(Box.createRigidArea(WindowsFileChooserUI.hstrut10));
        comp.add(createToolButton(this.getChangeToParentDirectoryAction(), this.upFolderIcon, this.upFolderToolTipText, this.upFolderAccessibleName));
        if (!UIManager.getBoolean("FileChooser.readOnly")) {
            comp.add(createToolButton(this.filePane.getNewFolderAction(), this.newFolderIcon, this.newFolderToolTipText, this.newFolderAccessibleName));
        }
        ButtonGroup o = new ButtonGroup();
        final Object o2 = new JPopupMenu();
        final Object o3 = new JRadioButtonMenuItem(this.filePane.getViewTypeAction(0));
        o3.setSelected(this.filePane.getViewType() == 0);
        o2.add(o3);
        o.add(o3);
        final Object o4 = new JRadioButtonMenuItem(this.filePane.getViewTypeAction(1));
        o4.setSelected(this.filePane.getViewType() == 1);
        o2.add(o4);
        o.add(o4);
        BufferedImage image = new BufferedImage(this.viewMenuIcon.getIconWidth() + 7, this.viewMenuIcon.getIconHeight(), 2);
        Graphics graphics = image.getGraphics();
        this.viewMenuIcon.paintIcon(this.filePane, graphics, 0, 0);
        int n = image.getWidth() - 5;
        int n2 = image.getHeight() / 2 - 1;
        graphics.setColor(Color.BLACK);
        graphics.fillPolygon(new int[] { n, n + 5, n + 2 }, new int[] { n2, n2, n2 + 3 }, 3);
        final JButton toolButton = createToolButton(null, new ImageIcon(image), this.viewMenuButtonToolTipText, this.viewMenuButtonAccessibleName);
        toolButton.addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent anEvent) {
                if (SwingUtilities.isLeftMouseButton(anEvent) && !toolButton.isSelected()) {
                    toolButton.setSelected(true);
                    o2.show(toolButton, 0, toolButton.getHeight());
                }
            }
        });
        toolButton.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent keyEvent) {
                if (keyEvent.getKeyCode() == 32 && toolButton.getModel().isRollover()) {
                    toolButton.setSelected(true);
                    o2.show(toolButton, 0, toolButton.getHeight());
                }
            }
        });
        o2.addPopupMenuListener(new PopupMenuListener() {
            @Override
            public void popupMenuWillBecomeVisible(PopupMenuEvent popupMenuEvent) {
            }
            
            @Override
            public void popupMenuWillBecomeInvisible(PopupMenuEvent popupMenuEvent) {
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {
                        toolButton.setSelected(false);
                    }
                });
            }
            
            @Override
            public void popupMenuCanceled(PopupMenuEvent popupMenuEvent) {
            }
        });
        comp.add(toolButton);
        comp.add(Box.createRigidArea(new Dimension(80, 0)));
        this.filePane.addPropertyChangeListener(new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent propertyChangeEvent) {
                if ("viewType".equals(propertyChangeEvent.getPropertyName())) {
                    switch (WindowsFileChooserUI.this.filePane.getViewType()) {
                        case 0: {
                            o3.setSelected(true);
                            break;
                        }
                        case 1: {
                            o4.setSelected(true);
                            break;
                        }
                    }
                }
            }
        });
        (this.centerPanel = new JPanel(new BorderLayout())).add(this.getAccessoryPanel(), "After");
        JComponent accessory = fc.getAccessory();
        if (accessory != null) {
            this.getAccessoryPanel().add(accessory);
        }
        this.filePane.setPreferredSize(WindowsFileChooserUI.LIST_PREF_SIZE);
        this.centerPanel.add(this.filePane, "Center");
        fc.add(this.centerPanel, "Center");
        this.getBottomPanel().setLayout(new BoxLayout(this.getBottomPanel(), 2));
        this.centerPanel.add(this.getBottomPanel(), "South");
        JPanel o5 = new JPanel();
        o5.setLayout(new BoxLayout(o5, 3));
        o5.add(Box.createRigidArea(WindowsFileChooserUI.vstrut4));
        this.fileNameLabel = new JLabel();
        this.populateFileNameLabel();
        this.fileNameLabel.setAlignmentY(0.0f);
        o5.add(this.fileNameLabel);
        o5.add(Box.createRigidArea(new Dimension(1, 12)));
        JLabel comp2 = new JLabel(this.filesOfTypeLabelText);
        comp2.setDisplayedMnemonic(this.filesOfTypeLabelMnemonic);
        o5.add(comp2);
        this.getBottomPanel().add(o5);
        this.getBottomPanel().add(Box.createRigidArea(new Dimension(15, 0)));
        JPanel o6 = new JPanel();
        o6.add(Box.createRigidArea(WindowsFileChooserUI.vstrut8));
        o6.setLayout(new BoxLayout(o6, 1));
        this.filenameTextField = new JTextField(35) {
            @Override
            public Dimension getMaximumSize() {
                return new Dimension(32767, super.getPreferredSize().height);
            }
        };
        this.fileNameLabel.setLabelFor(this.filenameTextField);
        this.filenameTextField.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(FocusEvent focusEvent) {
                if (!WindowsFileChooserUI.this.getFileChooser().isMultiSelectionEnabled()) {
                    WindowsFileChooserUI.this.filePane.clearSelection();
                }
            }
        });
        if (fc.isMultiSelectionEnabled()) {
            this.setFileName(this.fileNameString(fc.getSelectedFiles()));
        }
        else {
            this.setFileName(this.fileNameString(fc.getSelectedFile()));
        }
        o6.add(this.filenameTextField);
        o6.add(Box.createRigidArea(WindowsFileChooserUI.vstrut8));
        fc.addPropertyChangeListener(this.filterComboBoxModel = this.createFilterComboBoxModel());
        comp2.setLabelFor(this.filterComboBox = new JComboBox(this.filterComboBoxModel));
        this.filterComboBox.setRenderer(this.createFilterComboBoxRenderer());
        o6.add(this.filterComboBox);
        this.getBottomPanel().add(o6);
        this.getBottomPanel().add(Box.createRigidArea(new Dimension(30, 0)));
        this.getButtonPanel().setLayout(new BoxLayout(this.getButtonPanel(), 1));
        this.approveButton = new JButton(this.getApproveButtonText(fc)) {
            @Override
            public Dimension getMaximumSize() {
                return (WindowsFileChooserUI.this.approveButton.getPreferredSize().width > WindowsFileChooserUI.this.cancelButton.getPreferredSize().width) ? WindowsFileChooserUI.this.approveButton.getPreferredSize() : WindowsFileChooserUI.this.cancelButton.getPreferredSize();
            }
        };
        Insets margin = this.approveButton.getMargin();
        InsetsUIResource o7 = new InsetsUIResource(margin.top, margin.left + 5, margin.bottom, margin.right + 5);
        this.approveButton.setMargin(o7);
        this.approveButton.setMnemonic(this.getApproveButtonMnemonic(fc));
        this.approveButton.addActionListener(this.getApproveSelectionAction());
        this.approveButton.setToolTipText(this.getApproveButtonToolTipText(fc));
        this.getButtonPanel().add(Box.createRigidArea(WindowsFileChooserUI.vstrut6));
        this.getButtonPanel().add(this.approveButton);
        this.getButtonPanel().add(Box.createRigidArea(WindowsFileChooserUI.vstrut4));
        (this.cancelButton = new JButton(this.cancelButtonText) {
            @Override
            public Dimension getMaximumSize() {
                return (WindowsFileChooserUI.this.approveButton.getPreferredSize().width > WindowsFileChooserUI.this.cancelButton.getPreferredSize().width) ? WindowsFileChooserUI.this.approveButton.getPreferredSize() : WindowsFileChooserUI.this.cancelButton.getPreferredSize();
            }
        }).setMargin(o7);
        this.cancelButton.setToolTipText(this.cancelButtonToolTipText);
        this.cancelButton.addActionListener(this.getCancelSelectionAction());
        this.getButtonPanel().add(this.cancelButton);
        if (fc.getControlButtonsAreShown()) {
            this.addControlButtons();
        }
    }
    
    private void updateUseShellFolder() {
        JFileChooser fileChooser = this.getFileChooser();
        if (FilePane.usesShellFolder(fileChooser)) {
            if (this.placesBar == null && !UIManager.getBoolean("FileChooser.noPlacesBar")) {
                fileChooser.add(this.placesBar = new WindowsPlacesBar(fileChooser, XPStyle.getXP() != null), "Before");
                fileChooser.addPropertyChangeListener(this.placesBar);
            }
        }
        else if (this.placesBar != null) {
            fileChooser.remove(this.placesBar);
            fileChooser.removePropertyChangeListener(this.placesBar);
            this.placesBar = null;
        }
    }
    
    protected JPanel getButtonPanel() {
        if (this.buttonPanel == null) {
            this.buttonPanel = new JPanel();
        }
        return this.buttonPanel;
    }
    
    protected JPanel getBottomPanel() {
        if (this.bottomPanel == null) {
            this.bottomPanel = new JPanel();
        }
        return this.bottomPanel;
    }
    
    @Override
    protected void installStrings(JFileChooser fc) {
        super.installStrings(fc);
        Locale locale = fc.getLocale();
        this.lookInLabelMnemonic = (int)this.getMnemonic("FileChooser.lookInLabelMnemonic", locale);
        this.lookInLabelText = UIManager.getString("FileChooser.lookInLabelText", locale);
        this.saveInLabelText = UIManager.getString("FileChooser.saveInLabelText", locale);
        this.fileNameLabelMnemonic = (int)this.getMnemonic("FileChooser.fileNameLabelMnemonic", locale);
        this.fileNameLabelText = UIManager.getString("FileChooser.fileNameLabelText", locale);
        this.folderNameLabelMnemonic = (int)this.getMnemonic("FileChooser.folderNameLabelMnemonic", locale);
        this.folderNameLabelText = UIManager.getString("FileChooser.folderNameLabelText", locale);
        this.filesOfTypeLabelMnemonic = (int)this.getMnemonic("FileChooser.filesOfTypeLabelMnemonic", locale);
        this.filesOfTypeLabelText = UIManager.getString("FileChooser.filesOfTypeLabelText", locale);
        this.upFolderToolTipText = UIManager.getString("FileChooser.upFolderToolTipText", locale);
        this.upFolderAccessibleName = UIManager.getString("FileChooser.upFolderAccessibleName", locale);
        this.newFolderToolTipText = UIManager.getString("FileChooser.newFolderToolTipText", locale);
        this.newFolderAccessibleName = UIManager.getString("FileChooser.newFolderAccessibleName", locale);
        this.viewMenuButtonToolTipText = UIManager.getString("FileChooser.viewMenuButtonToolTipText", locale);
        this.viewMenuButtonAccessibleName = UIManager.getString("FileChooser.viewMenuButtonAccessibleName", locale);
    }
    
    private Integer getMnemonic(String key, Locale l) {
        return Integer.valueOf(SwingUtilities2.getUIDefaultsInt(key, l));
    }
    
    @Override
    protected void installListeners(JFileChooser fileChooser) {
        super.installListeners(fileChooser);
        SwingUtilities.replaceUIActionMap(fileChooser, this.getActionMap());
    }
    
    protected ActionMap getActionMap() {
        return this.createActionMap();
    }
    
    protected ActionMap createActionMap() {
        ActionMapUIResource map = new ActionMapUIResource();
        FilePane.addActionsToMap(map, this.filePane.getActions());
        return map;
    }
    
    protected JPanel createList(JFileChooser fileChooser) {
        return this.filePane.createList();
    }
    
    protected JPanel createDetailsView(JFileChooser fileChooser) {
        return this.filePane.createDetailsView();
    }
    
    @Override
    public ListSelectionListener createListSelectionListener(JFileChooser fc) {
        return super.createListSelectionListener(fc);
    }
    
    @Override
    public void uninstallUI(JComponent c) {
        c.removePropertyChangeListener(this.filterComboBoxModel);
        c.removePropertyChangeListener(this.filePane);
        if (this.placesBar != null) {
            c.removePropertyChangeListener(this.placesBar);
        }
        this.cancelButton.removeActionListener(this.getCancelSelectionAction());
        this.approveButton.removeActionListener(this.getApproveSelectionAction());
        this.filenameTextField.removeActionListener(this.getApproveSelectionAction());
        if (this.filePane != null) {
            this.filePane.uninstallUI();
            this.filePane = null;
        }
        super.uninstallUI(c);
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        int width = WindowsFileChooserUI.PREF_SIZE.width;
        Dimension preferredLayoutSize = component.getLayout().preferredLayoutSize(component);
        if (preferredLayoutSize != null) {
            return new Dimension((preferredLayoutSize.width < width) ? width : preferredLayoutSize.width, (preferredLayoutSize.height < WindowsFileChooserUI.PREF_SIZE.height) ? WindowsFileChooserUI.PREF_SIZE.height : preferredLayoutSize.height);
        }
        return new Dimension(width, WindowsFileChooserUI.PREF_SIZE.height);
    }
    
    @Override
    public Dimension getMinimumSize(JComponent component) {
        return new Dimension(WindowsFileChooserUI.MIN_WIDTH, WindowsFileChooserUI.MIN_HEIGHT);
    }
    
    @Override
    public Dimension getMaximumSize(JComponent component) {
        return new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE);
    }
    
    private String fileNameString(File dir) {
        if (dir == null) {
            return null;
        }
        JFileChooser fileChooser = this.getFileChooser();
        if ((fileChooser.isDirectorySelectionEnabled() && !fileChooser.isFileSelectionEnabled()) || (fileChooser.isDirectorySelectionEnabled() && fileChooser.isFileSelectionEnabled() && fileChooser.getFileSystemView().isFileSystemRoot(dir))) {
            return dir.getPath();
        }
        return dir.getName();
    }
    
    private String fileNameString(File[] array) {
        StringBuffer sb = new StringBuffer();
        for (int n = 0; array != null && n < array.length; ++n) {
            if (n > 0) {
                sb.append(" ");
            }
            if (array.length > 1) {
                sb.append("\"");
            }
            sb.append(this.fileNameString(array[n]));
            if (array.length > 1) {
                sb.append("\"");
            }
        }
        return sb.toString();
    }
    
    private void doSelectedFileChanged(PropertyChangeEvent propertyChangeEvent) {
        File file = (File)propertyChangeEvent.getNewValue();
        JFileChooser fileChooser = this.getFileChooser();
        if (file != null && ((fileChooser.isFileSelectionEnabled() && !file.isDirectory()) || (file.isDirectory() && fileChooser.isDirectorySelectionEnabled()))) {
            this.setFileName(this.fileNameString(file));
        }
    }
    
    private void doSelectedFilesChanged(PropertyChangeEvent propertyChangeEvent) {
        File[] array = (File[])(File[])propertyChangeEvent.getNewValue();
        JFileChooser fileChooser = this.getFileChooser();
        if (array != null && array.length > 0 && (array.length > 1 || fileChooser.isDirectorySelectionEnabled() || !array[0].isDirectory())) {
            this.setFileName(this.fileNameString(array));
        }
    }
    
    private void doDirectoryChanged(PropertyChangeEvent propertyChangeEvent) {
        JFileChooser fileChooser = this.getFileChooser();
        FileSystemView fileSystemView = fileChooser.getFileSystemView();
        this.clearIconCache();
        File currentDirectory = fileChooser.getCurrentDirectory();
        if (currentDirectory != null) {
            WindowsFileChooserUI.DirectoryComboBoxModel.access$800(this.directoryComboBoxModel, currentDirectory);
            if (fileChooser.isDirectorySelectionEnabled() && !fileChooser.isFileSelectionEnabled()) {
                if (fileSystemView.isFileSystem(currentDirectory)) {
                    this.setFileName(currentDirectory.getPath());
                }
                else {
                    this.setFileName(null);
                }
            }
        }
    }
    
    private void doFilterChanged(PropertyChangeEvent propertyChangeEvent) {
        this.clearIconCache();
    }
    
    private void doFileSelectionModeChanged(PropertyChangeEvent propertyChangeEvent) {
        if (this.fileNameLabel != null) {
            this.populateFileNameLabel();
        }
        this.clearIconCache();
        JFileChooser fileChooser = this.getFileChooser();
        File currentDirectory = fileChooser.getCurrentDirectory();
        if (currentDirectory != null && fileChooser.isDirectorySelectionEnabled() && !fileChooser.isFileSelectionEnabled() && fileChooser.getFileSystemView().isFileSystem(currentDirectory)) {
            this.setFileName(currentDirectory.getPath());
        }
        else {
            this.setFileName(null);
        }
    }
    
    private void doAccessoryChanged(PropertyChangeEvent propertyChangeEvent) {
        if (this.getAccessoryPanel() != null) {
            if (propertyChangeEvent.getOldValue() != null) {
                this.getAccessoryPanel().remove((JComponent)propertyChangeEvent.getOldValue());
            }
            JComponent comp = (JComponent)propertyChangeEvent.getNewValue();
            if (comp != null) {
                this.getAccessoryPanel().add(comp, "Center");
            }
        }
    }
    
    private void doApproveButtonTextChanged(PropertyChangeEvent propertyChangeEvent) {
        JFileChooser fileChooser = this.getFileChooser();
        this.approveButton.setText(this.getApproveButtonText(fileChooser));
        this.approveButton.setToolTipText(this.getApproveButtonToolTipText(fileChooser));
        this.approveButton.setMnemonic(this.getApproveButtonMnemonic(fileChooser));
    }
    
    private void doDialogTypeChanged(PropertyChangeEvent propertyChangeEvent) {
        JFileChooser fileChooser = this.getFileChooser();
        this.approveButton.setText(this.getApproveButtonText(fileChooser));
        this.approveButton.setToolTipText(this.getApproveButtonToolTipText(fileChooser));
        this.approveButton.setMnemonic(this.getApproveButtonMnemonic(fileChooser));
        if (fileChooser.getDialogType() == 1) {
            this.lookInLabel.setText(this.saveInLabelText);
        }
        else {
            this.lookInLabel.setText(this.lookInLabelText);
        }
    }
    
    private void doApproveButtonMnemonicChanged(PropertyChangeEvent propertyChangeEvent) {
        this.approveButton.setMnemonic(this.getApproveButtonMnemonic(this.getFileChooser()));
    }
    
    private void doControlButtonsChanged(PropertyChangeEvent propertyChangeEvent) {
        if (this.getFileChooser().getControlButtonsAreShown()) {
            this.addControlButtons();
        }
        else {
            this.removeControlButtons();
        }
    }
    
    @Override
    public PropertyChangeListener createPropertyChangeListener(JFileChooser fileChooser) {
        return new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent propertyChangeEvent) {
                String propertyName = propertyChangeEvent.getPropertyName();
                if (propertyName.equals("SelectedFileChangedProperty")) {
                    WindowsFileChooserUI.access$900(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("SelectedFilesChangedProperty")) {
                    WindowsFileChooserUI.access$1000(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("directoryChanged")) {
                    WindowsFileChooserUI.access$1100(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("fileFilterChanged")) {
                    WindowsFileChooserUI.access$1200(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("fileSelectionChanged")) {
                    WindowsFileChooserUI.access$1300(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("AccessoryChangedProperty")) {
                    WindowsFileChooserUI.access$1400(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("ApproveButtonTextChangedProperty") || propertyName.equals("ApproveButtonToolTipTextChangedProperty")) {
                    WindowsFileChooserUI.access$1500(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("DialogTypeChangedProperty")) {
                    WindowsFileChooserUI.access$1600(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("ApproveButtonMnemonicChangedProperty")) {
                    WindowsFileChooserUI.access$1700(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("ControlButtonsAreShownChangedProperty")) {
                    WindowsFileChooserUI.access$1800(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName == "FileChooser.useShellFolder") {
                    WindowsFileChooserUI.access$1900(WindowsFileChooserUI.this);
                    WindowsFileChooserUI.access$1100(WindowsFileChooserUI.this, propertyChangeEvent);
                }
                else if (propertyName.equals("componentOrientation")) {
                    ComponentOrientation o = (ComponentOrientation)propertyChangeEvent.getNewValue();
                    JFileChooser fileChooser = (JFileChooser)propertyChangeEvent.getSource();
                    if (o != propertyChangeEvent.getOldValue()) {
                        fileChooser.applyComponentOrientation(o);
                    }
                }
                else if (propertyName.equals("ancestor") && propertyChangeEvent.getOldValue() == null && propertyChangeEvent.getNewValue() != null) {
                    WindowsFileChooserUI.this.filenameTextField.selectAll();
                    WindowsFileChooserUI.this.filenameTextField.requestFocus();
                }
            }
        };
    }
    
    protected void removeControlButtons() {
        this.getBottomPanel().remove(this.getButtonPanel());
    }
    
    protected void addControlButtons() {
        this.getBottomPanel().add(this.getButtonPanel());
    }
    
    @Override
    public void ensureFileIsVisible(JFileChooser fc, File f) {
        this.filePane.ensureFileIsVisible(fc, f);
    }
    
    @Override
    public void rescanCurrentDirectory(JFileChooser fileChooser) {
        this.filePane.rescanCurrentDirectory();
    }
    
    @Override
    public String getFileName() {
        if (this.filenameTextField != null) {
            return this.filenameTextField.getText();
        }
        return null;
    }
    
    @Override
    public void setFileName(String text) {
        if (this.filenameTextField != null) {
            this.filenameTextField.setText(text);
        }
    }
    
    @Override
    protected void setDirectorySelected(boolean directorySelected) {
        super.setDirectorySelected(directorySelected);
        JFileChooser fileChooser = this.getFileChooser();
        if (directorySelected) {
            this.approveButton.setText(this.directoryOpenButtonText);
            this.approveButton.setToolTipText(this.directoryOpenButtonToolTipText);
            this.approveButton.setMnemonic(this.directoryOpenButtonMnemonic);
        }
        else {
            this.approveButton.setText(this.getApproveButtonText(fileChooser));
            this.approveButton.setToolTipText(this.getApproveButtonToolTipText(fileChooser));
            this.approveButton.setMnemonic(this.getApproveButtonMnemonic(fileChooser));
        }
    }
    
    @Override
    public String getDirectoryName() {
        return null;
    }
    
    @Override
    public void setDirectoryName(String s) {
    }
    
    protected WindowsFileChooserUI.DirectoryComboBoxRenderer createDirectoryComboBoxRenderer(JFileChooser fileChooser) {
        return new WindowsFileChooserUI.DirectoryComboBoxRenderer();
    }
    
    private static JButton createToolButton(Action a, Icon icon, String toolTipText, String value) {
        final JButton button = new JButton(a);
        button.setText(null);
        button.setIcon(icon);
        button.setToolTipText(toolTipText);
        button.setRequestFocusEnabled(false);
        button.putClientProperty("AccessibleName", value);
        button.putClientProperty(WindowsLookAndFeel.HI_RES_DISABLED_ICON_CLIENT_KEY, Boolean.TRUE);
        button.setAlignmentX(0.0f);
        button.setAlignmentY(0.5f);
        button.setMargin(WindowsFileChooserUI.shrinkwrap);
        button.setFocusPainted(false);
        button.setModel(new DefaultButtonModel() {
            @Override
            public void setPressed(boolean pressed) {
                if (!pressed || this.isRollover()) {
                    super.setPressed(pressed);
                }
            }
            
            @Override
            public void setRollover(boolean rollover) {
                if (rollover && !this.isRollover()) {
                    for (Component component : button.getParent().getComponents()) {
                        if (component instanceof JButton && component != button) {
                            ((JButton)component).getModel().setRollover(false);
                        }
                    }
                }
                super.setRollover(rollover);
            }
            
            @Override
            public void setSelected(boolean selected) {
                super.setSelected(selected);
                if (selected) {
                    this.stateMask |= 0x5;
                }
                else {
                    this.stateMask &= 0xFFFFFFFA;
                }
            }
        });
        button.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(FocusEvent focusEvent) {
                button.getModel().setRollover(true);
            }
            
            @Override
            public void focusLost(FocusEvent focusEvent) {
                button.getModel().setRollover(false);
            }
        });
        return button;
    }
    
    protected WindowsFileChooserUI.DirectoryComboBoxModel createDirectoryComboBoxModel(JFileChooser fileChooser) {
        return new WindowsFileChooserUI.DirectoryComboBoxModel();
    }
    
    protected WindowsFileChooserUI.FilterComboBoxRenderer createFilterComboBoxRenderer() {
        return new WindowsFileChooserUI.FilterComboBoxRenderer();
    }
    
    protected WindowsFileChooserUI.FilterComboBoxModel createFilterComboBoxModel() {
        return new WindowsFileChooserUI.FilterComboBoxModel();
    }
    
    public void valueChanged(ListSelectionEvent listSelectionEvent) {
        File selectedFile = this.getFileChooser().getSelectedFile();
        if (!listSelectionEvent.getValueIsAdjusting() && selectedFile != null && !this.getFileChooser().isTraversable(selectedFile)) {
            this.setFileName(this.fileNameString(selectedFile));
        }
    }
    
    @Override
    protected JButton getApproveButton(JFileChooser fileChooser) {
        return this.approveButton;
    }
    
    @Override
    public FileView getFileView(JFileChooser fileChooser) {
        return this.fileView;
    }
    
    static boolean access$000(WindowsFileChooserUI windowsFileChooserUI) {
        return windowsFileChooserUI.isDirectorySelected();
    }
    
    static File access$100(WindowsFileChooserUI windowsFileChooserUI) {
        return windowsFileChooserUI.getDirectory();
    }
    
    static MouseListener access$200(WindowsFileChooserUI windowsFileChooserUI, JFileChooser fc, JList list) {
        return windowsFileChooserUI.createDoubleClickListener(fc, list);
    }
    
    static void access$900(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doSelectedFileChanged(propertyChangeEvent);
    }
    
    static void access$1000(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doSelectedFilesChanged(propertyChangeEvent);
    }
    
    static void access$1100(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doDirectoryChanged(propertyChangeEvent);
    }
    
    static void access$1200(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doFilterChanged(propertyChangeEvent);
    }
    
    static void access$1300(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doFileSelectionModeChanged(propertyChangeEvent);
    }
    
    static void access$1400(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doAccessoryChanged(propertyChangeEvent);
    }
    
    static void access$1500(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doApproveButtonTextChanged(propertyChangeEvent);
    }
    
    static void access$1600(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doDialogTypeChanged(propertyChangeEvent);
    }
    
    static void access$1700(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doApproveButtonMnemonicChanged(propertyChangeEvent);
    }
    
    static void access$1800(WindowsFileChooserUI windowsFileChooserUI, PropertyChangeEvent propertyChangeEvent) {
        windowsFileChooserUI.doControlButtonsChanged(propertyChangeEvent);
    }
    
    static void access$1900(WindowsFileChooserUI windowsFileChooserUI) {
        windowsFileChooserUI.updateUseShellFolder();
    }
    
    static {
        hstrut10 = new Dimension(10, 1);
        vstrut4 = new Dimension(1, 4);
        vstrut6 = new Dimension(1, 6);
        vstrut8 = new Dimension(1, 8);
        shrinkwrap = new Insets(0, 0, 0, 0);
        WindowsFileChooserUI.PREF_WIDTH = 425;
        WindowsFileChooserUI.PREF_HEIGHT = 245;
        WindowsFileChooserUI.PREF_SIZE = new Dimension(WindowsFileChooserUI.PREF_WIDTH, WindowsFileChooserUI.PREF_HEIGHT);
        WindowsFileChooserUI.MIN_WIDTH = 425;
        WindowsFileChooserUI.MIN_HEIGHT = 245;
        WindowsFileChooserUI.LIST_PREF_WIDTH = 444;
        WindowsFileChooserUI.LIST_PREF_HEIGHT = 138;
        WindowsFileChooserUI.LIST_PREF_SIZE = new Dimension(WindowsFileChooserUI.LIST_PREF_WIDTH, WindowsFileChooserUI.LIST_PREF_HEIGHT);
    }
    
    private class WindowsFileChooserUIAccessor implements FilePane.FileChooserUIAccessor
    {
        @Override
        public JFileChooser getFileChooser() {
            return WindowsFileChooserUI.this.getFileChooser();
        }
        
        @Override
        public BasicDirectoryModel getModel() {
            return WindowsFileChooserUI.this.getModel();
        }
        
        @Override
        public JPanel createList() {
            return WindowsFileChooserUI.this.createList(this.getFileChooser());
        }
        
        @Override
        public JPanel createDetailsView() {
            return WindowsFileChooserUI.this.createDetailsView(this.getFileChooser());
        }
        
        @Override
        public boolean isDirectorySelected() {
            return WindowsFileChooserUI.access$000(WindowsFileChooserUI.this);
        }
        
        @Override
        public File getDirectory() {
            return WindowsFileChooserUI.access$100(WindowsFileChooserUI.this);
        }
        
        @Override
        public Action getChangeToParentDirectoryAction() {
            return WindowsFileChooserUI.this.getChangeToParentDirectoryAction();
        }
        
        @Override
        public Action getApproveSelectionAction() {
            return WindowsFileChooserUI.this.getApproveSelectionAction();
        }
        
        @Override
        public Action getNewFolderAction() {
            return WindowsFileChooserUI.this.getNewFolderAction();
        }
        
        @Override
        public MouseListener createDoubleClickListener(JList list) {
            return WindowsFileChooserUI.access$200(WindowsFileChooserUI.this, this.getFileChooser(), list);
        }
        
        @Override
        public ListSelectionListener createListSelectionListener() {
            return WindowsFileChooserUI.this.createListSelectionListener(this.getFileChooser());
        }
    }
    
    protected class WindowsNewFolderAction extends BasicFileChooserUI.NewFolderAction
    {
    }
    
    protected class SingleClickListener extends MouseAdapter
    {
    }
    
    protected class FileRenderer extends DefaultListCellRenderer
    {
    }
    
    class DirectoryComboBoxRenderer extends DefaultListCellRenderer
    {
        WindowsFileChooserUI.IndentIcon ii;
        
        DirectoryComboBoxRenderer() {
            this.ii = new WindowsFileChooserUI.IndentIcon();
        }
        
        @Override
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
            if (value == null) {
                this.setText("");
                return this;
            }
            File file = (File)value;
            this.setText(WindowsFileChooserUI.this.getFileChooser().getName(file));
            this.ii.icon = WindowsFileChooserUI.this.getFileChooser().getIcon(file);
            this.ii.depth = WindowsFileChooserUI.this.directoryComboBoxModel.getDepth(index);
            this.setIcon(this.ii);
            return this;
        }
    }
    
    class IndentIcon implements Icon
    {
        Icon icon;
        int depth;
        
        IndentIcon() {
            this.icon = null;
            this.depth = 0;
        }
        
        @Override
        public void paintIcon(Component component, Graphics graphics, int n, int n2) {
            if (component.getComponentOrientation().isLeftToRight()) {
                this.icon.paintIcon(component, graphics, n + this.depth * 10, n2);
            }
            else {
                this.icon.paintIcon(component, graphics, n, n2);
            }
        }
        
        @Override
        public int getIconWidth() {
            return this.icon.getIconWidth() + this.depth * 10;
        }
        
        @Override
        public int getIconHeight() {
            return this.icon.getIconHeight();
        }
    }
    
    protected class DirectoryComboBoxModel extends AbstractListModel<File> implements ComboBoxModel<File>
    {
        Vector<File> directories;
        int[] depths;
        File selectedDirectory;
        JFileChooser chooser;
        FileSystemView fsv;
        
        public DirectoryComboBoxModel() {
            this.directories = new Vector();
            this.depths = null;
            this.selectedDirectory = null;
            this.chooser = WindowsFileChooserUI.this.getFileChooser();
            this.fsv = this.chooser.getFileSystemView();
            File currentDirectory = WindowsFileChooserUI.this.getFileChooser().getCurrentDirectory();
            if (currentDirectory != null) {
                this.addItem(currentDirectory);
            }
        }
        
        private void addItem(File file) {
            if (file == null) {
                return;
            }
            int usesShellFolder = FilePane.usesShellFolder(this.chooser);
            this.directories.clear();
            this.directories.addAll(Arrays.asList(usesShellFolder ? ((File[])(File[])ShellFolder.get("fileChooserComboBoxFolders")) : this.fsv.getRoots()));
            File selectedItem;
            try {
                selectedItem = file.getCanonicalFile();
            }
            catch (IOException ex) {
                selectedItem = file;
            }
            try {
                selectedItem = (selectedItem = (usesShellFolder ? ShellFolder.getShellFolder(selectedItem) : selectedItem));
                Vector o = new Vector(10);
                do {
                    o.addElement(selectedItem);
                } while ((selectedItem = selectedItem.getParentFile()) != null);
                int size = o.size();
                int i = 0;
                while (i < size) {
                    File file2 = (File)o.get(i);
                    if (this.directories.contains(file2)) {
                        int index = this.directories.indexOf(file2);
                        for (int j = i - 1; j >= 0; --j) {
                            this.directories.insertElementAt(o.get(j), index + i - j);
                        }
                        break;
                    }
                    ++i;
                }
                this.calculateDepths();
                this.setSelectedItem(selectedItem);
            }
            catch (FileNotFoundException ex2) {
                this.calculateDepths();
            }
            return;
        }
        
        private void calculateDepths() {
            this.depths = new int[this.directories.size()];
            for (int i = 0; i < this.depths.length; ++i) {
                File parentFile = ((File)this.directories.get(i)).getParentFile();
                this.depths[i] = 0;
                if (parentFile != null) {
                    int j = i - 1;
                    while (j >= 0) {
                        if (parentFile.equals(this.directories.get(j))) {
                            this.depths[i] = this.depths[j] + 1;
                            break;
                        }
                        --j;
                    }
                }
            }
        }
        
        public int getDepth(int n) {
            return (this.depths != null && n >= 0 && n < this.depths.length) ? this.depths[n] : 0;
        }
        
        @Override
        public void setSelectedItem(Object o) {
            this.selectedDirectory = (File)o;
            this.fireContentsChanged(this, -1, -1);
        }
        
        @Override
        public Object getSelectedItem() {
            return this.selectedDirectory;
        }
        
        @Override
        public int getSize() {
            return this.directories.size();
        }
        
        @Override
        public File getElementAt(int index) {
            return (File)this.directories.elementAt(index);
        }
        
        static void access$800(WindowsFileChooserUI.DirectoryComboBoxModel directoryComboBoxModel, File file) {
            directoryComboBoxModel.addItem(file);
        }
    }
    
    public class FilterComboBoxRenderer extends DefaultListCellRenderer
    {
        @Override
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
            if (value != null && value instanceof FileFilter) {
                this.setText(((FileFilter)value).getDescription());
                return this;
            }
            return this;
        }
    }
    
    protected class FilterComboBoxModel extends AbstractListModel<FileFilter> implements ComboBoxModel<FileFilter>, PropertyChangeListener
    {
        protected FileFilter[] filters;
        
        protected FilterComboBoxModel() {
            this.filters = WindowsFileChooserUI.this.getFileChooser().getChoosableFileFilters();
        }
        
        @Override
        public void propertyChange(PropertyChangeEvent propertyChangeEvent) {
            String propertyName = propertyChangeEvent.getPropertyName();
            if (propertyName == "ChoosableFileFilterChangedProperty") {
                this.filters = (FileFilter[])(FileFilter[])propertyChangeEvent.getNewValue();
                this.fireContentsChanged(this, -1, -1);
            }
            else if (propertyName == "fileFilterChanged") {
                this.fireContentsChanged(this, -1, -1);
            }
        }
        
        @Override
        public void setSelectedItem(Object o) {
            if (o != null) {
                WindowsFileChooserUI.this.getFileChooser().setFileFilter((FileFilter)o);
                this.fireContentsChanged(this, -1, -1);
            }
        }
        
        @Override
        public Object getSelectedItem() {
            FileFilter fileFilter = WindowsFileChooserUI.this.getFileChooser().getFileFilter();
            boolean n = false;
            if (fileFilter != null) {
                FileFilter[] filters = this.filters;
                for (int length = filters.length, i = 0; i < length; ++i) {
                    if (filters[i] == fileFilter) {
                        n = true;
                    }
                }
                if (n == 0) {
                    WindowsFileChooserUI.this.getFileChooser().addChoosableFileFilter(fileFilter);
                }
            }
            return WindowsFileChooserUI.this.getFileChooser().getFileFilter();
        }
        
        @Override
        public int getSize() {
            if (this.filters != null) {
                return this.filters.length;
            }
            return 0;
        }
        
        @Override
        public FileFilter getElementAt(int n) {
            if (n > this.getSize() - 1) {
                return WindowsFileChooserUI.this.getFileChooser().getFileFilter();
            }
            if (this.filters != null) {
                return this.filters[n];
            }
            return null;
        }
    }
    
    protected class DirectoryComboBoxAction implements ActionListener
    {
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            WindowsFileChooserUI.this.getFileChooser().setCurrentDirectory((File)WindowsFileChooserUI.this.directoryComboBox.getSelectedItem());
        }
    }
    
    protected class WindowsFileView extends BasicFileChooserUI.BasicFileView
    {
        @Override
        public Icon getIcon(File file) {
            Icon i = this.getCachedIcon(file);
            if (i != null) {
                return i;
            }
            if (file != null) {
                i = WindowsFileChooserUI.this.getFileChooser().getFileSystemView().getSystemIcon(file);
            }
            if (i == null) {
                i = super.getIcon(file);
            }
            this.cacheIcon(file, i);
            return i;
        }
    }
}
